#ifndef K3DSDK_RENDER_FARM_H
#define K3DSDK_RENDER_FARM_H

// K-3D
// Copyright (c) 1995-2004, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Provides an implementation of k3d::irender_farm
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3dsdk/irender_farm.h>

namespace boost { namespace filesystem { class path; } }

namespace k3d
{

/////////////////////////////////////////////////////////////////////////////
// render_farm

class render_farm :
	public irender_farm
{
public:
	render_farm(const boost::filesystem::path& OptionsPath);
	~render_farm();

	irender_job& create_job(const std::string JobName);
	void start_job(irender_job& Job);

private:
	class implementation;
	implementation* const m_implementation;
};

} // namespace k3d

#endif // K3DSDK_RENDER_FARM_H


