#ifndef K3DUI_CONNECT_PROPERTIES_H
#define K3DUI_CONNECT_PROPERTIES_H

// K-3D
// Copyright (c) 1995-2004, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Provides a user interface for connecting properties using the DAG
		\author Tim Shead (tshead@k-3d.com)
*/

namespace k3d
{

// Forward declarations
class idocument;
class iobject;
class iproperty;

/// Creates a modeless dialog that can connect properties - note: any combination of parameters may be NULL
void create_connect_properties_dialog(idocument& Document, iobject* const SourceObject, iproperty* const SourceProperty, iobject* const DestinationObject, iproperty* const DestinationProperty);

} // namespace k3d

#endif // !K3DUI_CONNECT_PROPERTIES_H

