#ifndef K3DUI_DAG_WINDOW_H
#define K3DUI_DAG_WINDOW_H

// K-3D
// Copyright (c) 1995-2004, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief Declares the dag_window class, which can be used to visualize the DAG for a specific document
		\author Tim Shead (tshead@k-3d.com)
*/

#include <k3dsdk/signal_system.h>

namespace k3d
{

/////////////////////////////////////////////////////////////////////////////
// dag_window

class dag_window :
	public SigC::Object
{
public:
	dag_window(idocument& Document);
	~dag_window();

private:
	void on_close();

	class implementation;
	implementation* const m_implementation;
};

} // namespace k3d

#endif // K3DUI_DAG_WINDOW_H


