#ifndef SDPGL_H
#define SDPGL_H

// SDPGL
// Copyright (c) 1995-2004, Timothy M. Shead
//
// Contact: tshead@k-3d.com
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public
// License as published by the Free Software Foundation; either
// version 2 of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// General Public License for more details.
//
// You should have received a copy of the GNU General Public
// License along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

/** \file
		\brief The top-level include file for SDPGL
		\author Tim Shead (tshead@k-3d.com)
*/

#include "platform.h"

#if defined SDPGL_WIN32
 #include <windows.h>
#else // SDPGL_POSIX
 #include <GL/glx.h>
#endif // !SDPGL_POSIX

#include <GL/gl.h>
#include <GL/glu.h>

// _GLUfuncptr not defined in older GLU files
#ifndef _GLUfuncptr
typedef GLvoid (*_GLUfuncptr)(GLvoid);
#endif

#include "info.h"
#include "trace.h"
#include "utility.h"

#endif // SDPGL_H


